## portsentry 1.2

=== Makefile ===
# Makefile for PortSentry package.
# 
# Send problems/code hacks to help@psionic.com 
#
#
# STEALTH MODE: Only works on Linux systems right now.
#
# The snprintf included with the package is for use with NEXTSTEP only,
# (Thanks Timothy <tjl@luomat.org>) although it may work elsewhere.
# We've not tried it under any other OS to date. It shouldn't be needed
# by any modern OS.
#
# Others have used the snprintf from:
#
# http://www.ijs.si/software/snprintf/
#
# We've not tried this yet but others have had good success. Our only 
# piece of advice for those running an OS without built in snprintf()
# is to upgrade. :)
#
#
# Generic compiler (usually linked to gcc on most platforms)
CC = cc

# GNU..
#CC = gcc 

# Normal systems flags
CFLAGS = -O -Wall

# Debug mode for portsentry
#CFLAGS = -Wall -g -DNODAEMON -DDEBUG
#CFLAGS = -Wall -g -DNODAEMON
#CFLAGS = -Wall -g -DDEBUG

# Profiler mode for portsentry
#CFLAGS = -pg -O -Wall -DNODAEMON
#LIBS = /usr/lib/libefence.a

INSTALLDIR = /usr/local/psionic
CHILDDIR=/portsentry

all:
		@echo "Usage: make <systype>"
		@echo "<systype> is one of: linux, debian-linux, bsd, solaris, hpux, hpux-gcc,"
		@echo "freebsd, osx, openbsd, netbsd, bsdi, aix, osf, irix, generic"
		@echo "" 
		@echo "This code requires snprintf()/vsnprintf() system calls"
		@echo "to work. If you run a modern OS it should work on"
		@echo "your system with 'make generic'. If you get it to"
		@echo "work on an unlisted OS please write us with the" 
		@echo "changes." 
		@echo "" 
		@echo "Install: make install"
		@echo "" 
		@echo "NOTE: This will install the package in this" 
		@echo "      directory: $(INSTALLDIR)" 
		@echo "" 
		@echo "Edit the makefile if you wish to change these paths." 
		@echo "Any existing files will be overwritten."

clean:		
		/bin/rm ./portsentry

uninstall:	
		/bin/rm $(INSTALLDIR)$(CHILDDIR)/*
		/bin/rmdir $(INSTALLDIR)

install:	
		@echo "Creating psionic directory $(INSTALLDIR)"
		@if [ ! -d $(INSTALLDIR) ]; then /bin/mkdir $(INSTALLDIR); fi
		@echo "Setting directory permissions"
		@if [ "$(INSTALLDIR)" = "/usr/local/psionic" ]; then /bin/chmod 700 $(INSTALLDIR) ; fi
		@echo "Creating portsentry directory $(INSTALLDIR)$(CHILDDIR)"
		@if [ ! -d $(INSTALLDIR)$(CHILDDIR) ]; then /bin/mkdir\
			$(INSTALLDIR)$(CHILDDIR); fi
		@echo "Setting directory permissions"
		chmod 700 $(INSTALLDIR)$(CHILDDIR)
		@echo "Copying files"
		cp ./portsentry.conf $(INSTALLDIR)$(CHILDDIR)
		cp ./portsentry.ignore $(INSTALLDIR)$(CHILDDIR)
		cp ./portsentry $(INSTALLDIR)$(CHILDDIR)
		@echo "Setting permissions"
		chmod 600 $(INSTALLDIR)$(CHILDDIR)/portsentry.ignore
		chmod 600 $(INSTALLDIR)$(CHILDDIR)/portsentry.conf
		chmod 700 $(INSTALLDIR)$(CHILDDIR)/portsentry
		@echo ""
		@echo ""
		@echo "Edit $(INSTALLDIR)$(CHILDDIR)/portsentry.conf and change"
		@echo "your settings if you haven't already. (route, etc)" 
		@echo ""
		@echo ""
		@echo "WARNING: This version and above now use a new"
		@echo "directory structure for storing the program"
		@echo "and config files ($(INSTALLDIR)$(CHILDDIR))."
		@echo "Please make sure you delete the old files when" 
		@echo "the testing of this install is complete."
		@echo ""
		@echo ""

linux:		
		SYSTYPE=linux 
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DLINUX -DSUPPORT_STEALTH -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c $(LIBS)

debian-linux:		
		SYSTYPE=debian-linux 
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DLINUX -DDEBIAN -DSUPPORT_STEALTH -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c $(LIBS)


bsd:		
		SYSTYPE=bsd
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c


openbsd:		
		SYSTYPE=openbsd
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c


freebsd:		
		SYSTYPE=freebsd
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c

osx:		
		SYSTYPE=osx
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c


netbsd:		
		SYSTYPE=netbsd
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c


bsdi:		
		SYSTYPE=bsdi
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DBSD44 -o ./portsentry ./portsentry.c \
		./portsentry_io.c ./portsentry_util.c


generic:		
		SYSTYPE=generic
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c


hpux:		
		SYSTYPE=hpux
		@echo "Making $(SYSTYPE)"
		$(CC) -Ae -DHPUX -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c


hpux-gcc:
		SYSTYPE=hpux-gcc
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -DHPUX -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c 


solaris:		
		SYSTYPE=solaris
		@echo "Making $(SYSTYPE)"
		$(CC) -lnsl -lsocket -lresolv -lc -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c


aix:		
		SYSTYPE=aix
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c


osf:
		SYSTYPE=osf
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -taso -ldb -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c 


irix:
		SYSTYPE=irix
		@echo "Making $(SYSTYPE)"
		$(CC) $(CFLAGS) -O -n32 -mips3 -o ./portsentry ./portsentry.c ./portsentry_io.c \
		./portsentry_util.c 


# NeXTSTEP Users. NeXT used to work, but we changed the log function and
# it now uses vsnprintf() to format strings. This means that this
# version does not work under NeXTSTEP until we can find a workable
# vsnprintf() call to put in the program. Sorry. If you have some good
# vsnprintf() code to use under NeXT please send it to us and we'll 
# include it on the next update.
#next:		
#		SYSTYPE=next
#		@echo "Making $(SYSTYPE)"
#		$(CC) $(CFLAGS) -DNEXT -DHAS_NO_SNPRINTF -posix -o ./portsentry ./portsentry.c \
#		./portsentry_io.c ./portsentry_util.c

=== debian/changelog ===
portsentry (1.2-16) unstable; urgency=medium

  * Debian team upload.
  * Move aliased files from / to /usr (DEP17). (Closes: #1085161)

 -- Michael Biebl <biebl@debian.org>  Tue, 15 Oct 2024 18:19:00 +0200

portsentry (1.2-15) unstable; urgency=medium

  * Team upload by debian/ team
    Closes: #1081771

  [ Jelmer Vernooĳ ]
  * Migrate repository from alioth to salsa.

  [ Andreas Tille ]
  * debian/README.source: Replace redundant hint to quilt by hint how
    to possibly get latest commits from Github as new upstream source
  * debian/watch: Add comment to fetch latest upstream commit
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Rules-Requires-Root: binary-targets
  * Trim trailing whitespace.
  * Create automatically portsentry.history
    Closes: #1010718
  * d/rules: drop useless boilerplate comment
  * d/rules: short dh
  * d/rules: Enable hardening options

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #894974)
    + Let dh_auto_build pass cross tools to make.
    + Defer all stripping to dh_strip.

  [ Paulo Henrique de Lima Santana ]
  * Updated d/po/pt_BR.po (Closes: #1028013)

  [ наб ]
  * d/rules: no need for `pwd` or `dh_listpackages`
  * d/post{inst,rm}: stop supporting upgrades from 1.0-2 (unneeded since woody)
  * Add systemd service (Closes: #1039322)
    + the sysvinit unit starts 0/1/2 programs ad lib
    + this is unrepresentable in systemd
    + instead, mask it, ship template, and enable the appropriate
      portsentry@tcp.service and portsentry@udp.service
  * Make portsentry-build-ignore-file idempotent
  * debian/{po/{de,fr,nb}.po,portsentry.conf.5}: lintian national-encoding
  * d/prerm: lintian command-with-path-in-maintainer-script
  * d/control: lintian skip-systemd-native-flag-missing-pre-depends
  * d/NEWS: mention the new systemd setup

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 04 Oct 2024 01:05:13 +0200

portsentry (1.2-14) unstable; urgency=medium

  * debian/control:
    - Bump standards version to 3.9.2.
    - Update debhelper compatibility to 9
  * debian/patch:
    + Add debian/patches/01_dpkg-buildflags.diff to complete hardening
      options. Thanks to Guillaume Delacour <gui@iroqwa.org>
      (Closes: #763158)
  * debian/copyright:
    - Fix DEP-5 compatibility issues
    - Update copyright years
  * debian/portsentry.init.d:
    - Add source /lib/lsb/init-functions
    - Set Required-Start dependency to $syslog

 -- Dario Minnucci <midget@debian.org>  Wed, 29 Oct 2014 12:34:30 +0100

portsentry (1.2-13) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * debian/control:
    - Bump standards version to 3.9.2.
    - Remove references to quilt.
    - Update debhelper compatibility to 8.
    - Added Vcs-Git and Vcs-Browser fields.
  * debian/rules:
    - Remove references to quilt.
    - Added missing recommended targets (build-arch and build-indep)
  * debian/portsentry.docs:
    - Install upstream's changelog just once.
  * debian/copyright: Updated to be DEP-5 compatible.
  * debian/po:
    - Added Danish translation. Thanks to Joe Dalton. (Closes: #653746)

 -- Dario Minnucci <midget@debian.org>  Sat, 14 Jan 2012 15:28:20 +0100

portsentry (1.2-12) unstable; urgency=low

  * Adopting portsentry
  * Acknowledge NMU, thanks to Petter Reinholdtsen. (Closes: #547058)
  * debian/control:
    - Maintainers address updated
    - Added quilt to Build-Depends
    - Bump standard version to 3.8.3: Added debian/README.source
    - Adding 'Homepage:' field
    - Adding ${misc:Depends} to fix lintian W: debhelper-but-no-misc-depends
  * debian/watch: Added.
  * Move files and dirs outside upstream sources (into ./debian directory):
    - [DIR]  scripts
    - [FILE] portsentry.conf.Debian
    - [FILE] portsentry.ignore.static
  * Some files were renamed under debian directory:
    - debian/dirs   -->  debian/portsentry.dirs
    - debian/docs   -->  debian/portsentry.docs
    - debian/init.d -->  debian/portsentry.init.d
  * debian/rules: Added quilt support
  * debian/patches: Added patches to revert changes made on upstream files
    - 00_fix_Makefile.patch
    - 00_fix_portsentry_config.h.patch
    - 00_fix_portsentry.c.patch
    - 00_fix_README.install.patch


 -- Dario Minnucci <midget@debian.org>  Fri, 22 Jan 2010 12:32:46 +0100

portsentry (1.2-11.3) unstable; urgency=low

  * Non-maintainer upload to fix release goal.
  * Fix incorrect provides in init.d script (Closes: #542600).
  * Make init.d script depend on $all to start last in the boot sequence
    (Closes: #539257).
  * Fix typo in portsentry(8) manual page (Closes: #431304).
  * Remove redundant code from postinst.  The same code is inserted
    by dh_installinit.
  * Make sure errors are not ignored in prerm.
  * Move to debhelper versjon 7.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Sep 2009 00:13:57 +0200

portsentry (1.2-11.2) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Add LSB headers to init script. Closes: #462220
  * Debconf translations:
    - Vietnamese. Closes: #426849
    - Romanian. Closes: #411385
    - Norwegian Bokmål. Closes: #414463
    - Dutch. Closes: #419404
    - Finnish. Closes: #448189
    - Italian. Closes: #422006
  * [Lintian] Add a copyright mention in debian/copyright
  * [Lintian] Do not ignore errors from "make distclean" in
    debian/rules

 -- Christian Perrier <bubulle@debian.org>  Wed, 20 Feb 2008 20:02:49 +0100

portsentry (1.2-11.1) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Debconf translations:


=== debian/control ===
Source: portsentry
Maintainer: Dario Minnucci <midget@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/portsentry
Vcs-Git: https://salsa.debian.org/debian/portsentry.git
Homepage: http://sentrytools.sourceforge.net/
Rules-Requires-Root: binary-targets

Package: portsentry
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         net-tools,
         procps,
         libfile-temp-perl,
         debconf | debconf-2.0
Recommends: tcpd
Suggests: logcheck
Description: Portscan detection daemon
 PortSentry has the ability to detect portscans(including stealth scans) on
 the network interfaces of your machine. Upon alarm it can block the
 attacker via hosts.deny, dropped route or firewall rule. It is part of the
 Abacus program suite.
 .
 Note: If you  have no idea what a port/stealth scan is, It's recommended to
 have a look at http://sf.net/projects/sentrytools/ before installing this
 package. Otherwise you might easily block hosts you'd better not (e.g. your
 NFS-server, name-server, etc.).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" debian-linux

override_dh_auto_install:
	echo "Rely on dh_install"

override_dh_auto_clean:
	touch portsentry
	dh_auto_clean

override_dh_installinit:
	dh_installinit -u"defaults 99"

=== debian/watch ===
version=4
http://sf.net/sentrytools/portsentry-(.+)\.tar\.gz

# See README.source about fetching latest commits
#opts="mode=git,pretty=1.2+git%cd.%h" \
#    https://github.com/Perdjesk/portsentry.git HEAD

## portsentry 2.0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(portsentry VERSION 2.0.5)
include(CheckCCompilerFlag)

option(BUILD_FUZZER "Build fuzzer tests" OFF)
option(BUILD_TESTS "Build unit tests" OFF)
option(USE_PCAP "Build with pcap code and link with libpcap" ON)
option(INSTALL_LICENSE "Install license file" ON)

set(CONFIG_FILE "\"/etc/portsentry/portsentry.conf\"" CACHE STRING "Path to portsentry config file")
set(WRAPPER_HOSTS_DENY "\"/etc/hosts.deny\"" CACHE STRING "Path to hosts.deny file")

set(STANDARD_COMPILE_OPTS -Wall -Wextra -pedantic -Werror -Wformat -Wformat-security -Wstack-protector -Wshadow -Wredundant-decls -Wdisabled-optimization -Wnested-externs -Wstrict-overflow=2 -Wconversion -Wmissing-prototypes -fPIE -fstack-protector-strong -fstrict-aliasing -fno-common -fno-strict-overflow -D_FORTIFY_SOURCE=2)

check_c_compiler_flag("-fcf-protection=full" COMPILER_SUPPORTS_CFI_PROTECTION)

if (COMPILER_SUPPORTS_CFI_PROTECTION)
  set(STANDARD_COMPILE_OPTS ${STANDARD_COMPILE_OPTS} -fcf-protection=full)
endif()

set(STANDARD_LINK_OPTS -pie -Wl,-z,noexecstack -Wl,-z,now -Wl,-z,relro -Wl,-z,defs -Wl,--no-undefined)
set(CORE_SOURCE_FILES src/config_data.c src/configfile.c src/io.c src/util.c src/state_machine.c src/cmdline.c src/sentry_connect.c src/sighandler.c src/port.c src/packet_info.c src/ignore.c src/sentry.c src/block.c)

execute_process(COMMAND git log -1 --format=%h WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE GIT_COMMIT_HASH OUTPUT_STRIP_TRAILING_WHITESPACE)
add_definitions("-DGIT_COMMIT_HASH=\"${GIT_COMMIT_HASH}\"")

if (USE_PCAP)
  set(CORE_SOURCE_FILES ${CORE_SOURCE_FILES} src/pcap_listener.c src/pcap_device.c src/sentry_pcap.c)
  set(STANDARD_COMPILE_OPTS ${STANDARD_COMPILE_OPTS} -DUSE_PCAP)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CORE_SOURCE_FILES ${CORE_SOURCE_FILES} src/sentry_stealth.c)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CORE_SOURCE_FILES ${CORE_SOURCE_FILES} src/kernelmsg_linux.c)
elseif (CMAKE_SYSTEM_NAME STREQUAL "NetBSD" OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  set(CORE_SOURCE_FILES ${CORE_SOURCE_FILES} src/kernelmsg_bsd.c)
else()
  message(FATAL_ERROR "Unsupported operating system ${CMAKE_SYSTEM_NAME}")
endif()

configure_file(config.h.in config.h)

# CPack configuration
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(CPACK_DEBIAN_PACKAGE_NAME "portsentry")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.36), libpcap0.8 (>= 1.10.3)")
set(CPACK_DEBIAN_PACKAGE_SECTION "net")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Marcus Hufvudsson <mh@protohuf.com")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://portsentry.xyz")
set(CPACK_DEBIAN_PACKAGE_RECOMMENDS "fail2ban")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "A port scanning detection tool")

include(CPack)

# LIBPORTSENTRY - Static lib of the portsentry functionallity
add_library(lportsentry STATIC ${CORE_SOURCE_FILES})
target_compile_options(lportsentry PRIVATE ${STANDARD_COMPILE_OPTS})
target_include_directories(lportsentry PRIVATE "${PROJECT_BINARY_DIR}")
if (USE_PCAP)
  target_link_libraries(lportsentry INTERFACE pcap)
endif()

# PORTSENTRY - main program
add_executable(portsentry src/portsentry.c)
target_compile_options(portsentry PRIVATE ${STANDARD_COMPILE_OPTS})
target_include_directories(portsentry PRIVATE "${PROJECT_BINARY_DIR}")
target_link_options(portsentry PRIVATE ${STANDARD_LINK_OPTS})
target_link_libraries(portsentry PRIVATE lportsentry)
if (USE_PCAP)
  target_link_libraries(portsentry PRIVATE pcap)
endif()

# Check for pandoc and generate man pages if available
find_program(PANDOC_EXECUTABLE pandoc)
if(PANDOC_EXECUTABLE)
    add_custom_command(
        OUTPUT
            ${CMAKE_SOURCE_DIR}/man/portsentry.8
            ${CMAKE_SOURCE_DIR}/man/portsentry.conf.8
        COMMAND ${PANDOC_EXECUTABLE} --standalone --to man ${CMAKE_SOURCE_DIR}/docs/Manual.md -o ${CMAKE_SOURCE_DIR}/man/portsentry.8
        COMMAND ${PANDOC_EXECUTABLE} --standalone --to man ${CMAKE_SOURCE_DIR}/docs/portsentry.conf.md -o ${CMAKE_SOURCE_DIR}/man/portsentry.conf.8
        COMMENT "Generating man pages using pandoc"
    )
    add_custom_target(generate_man_pages DEPENDS
        ${CMAKE_SOURCE_DIR}/man/portsentry.8
        ${CMAKE_SOURCE_DIR}/man/portsentry.conf.8
    )
    add_dependencies(portsentry generate_man_pages)
endif()

# INSTALL TARGETS for portsentry program
include(GNUInstallDirs)

configure_file(init/portsentry.service.in init/portsentry.service @ONLY)

install(TARGETS portsentry DESTINATION ${CMAKE_INSTALL_SBINDIR})
install(FILES examples/portsentry.conf DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/portsentry)
install(FILES examples/portsentry.ignore DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/portsentry)
install(FILES examples/logrotate.conf DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/logrotate.d RENAME portsentry)
install(FILES man/portsentry.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)
install(FILES man/portsentry.conf.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)
install(DIRECTORY docs/ DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES Changes.md README.md DESTINATION ${CMAKE_INSTALL_DOCDIR})
if (INSTALL_LICENSE)
  install(FILES LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/init/portsentry.service DESTINATION ${CMAKE_INSTALL_LIBDIR}/systemd/system)

# PORTCON - helper test program used in system tests
add_executable(portcon portcon/main.c)
target_compile_options(portcon PRIVATE ${STANDARD_COMPILE_OPTS})
target_include_directories(portcon PRIVATE "${PROJECT_BINARY_DIR}")
target_link_options(portcon PRIVATE ${STANDARD_LINK_OPTS})

# FUZZER - fuzzer tests
if (CMAKE_C_COMPILER_ID STREQUAL "Clang" AND CMAKE_BUILD_TYPE STREQUAL "Debug" AND BUILD_FUZZER STREQUAL "ON")
  if (CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
    set(FUZZER_OPTS -fsanitize=fuzzer)
  else()
    set(FUZZER_OPTS -fsanitize=fuzzer,address)
  endif()

  add_executable(fuzz_sentry_pcap src/sentry_pcap.c)
  target_compile_options(fuzz_sentry_pcap PUBLIC -O1 -DFUZZ_SENTRY_PCAP_PREP_PACKET ${FUZZER_OPTS})
  target_include_directories(fuzz_sentry_pcap PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(fuzz_sentry_pcap PRIVATE ${FUZZER_OPTS})
  target_link_libraries(fuzz_sentry_pcap PRIVATE lportsentry)
  if (USE_PCAP)
    target_link_libraries(fuzz_sentry_pcap PRIVATE pcap)
  endif()

  add_executable(fuzz_sentry_stealth src/sentry_stealth.c)
  target_compile_options(fuzz_sentry_stealth PUBLIC -O1 -DFUZZ_SENTRY_STEALTH_PREP_PACKET ${FUZZER_OPTS})
  target_include_directories(fuzz_sentry_stealth PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(fuzz_sentry_stealth PRIVATE ${FUZZER_OPTS})
  target_link_libraries(fuzz_sentry_stealth PRIVATE lportsentry)
  if (USE_PCAP)
    target_link_libraries(fuzz_sentry_stealth PRIVATE pcap)
  endif()
endif()

# UNIT TESTS
if(BUILD_TESTS)
  set(UNIT_TEST_COMPILE_OPTS ${STANDARD_COMPILE_OPTS} -Wno-unused-result -Wno-unused-value -Wno-unused-variable -Wno-unused-but-set-variable)

  add_executable(test_util_safestrncpy tests/test_util_safestrncpy.c)
  target_compile_options(test_util_safestrncpy PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_util_safestrncpy PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_util_safestrncpy PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_util_safestrncpy PRIVATE lportsentry)

  add_executable(test_util_getlong tests/test_util_getlong.c)
  target_compile_options(test_util_getlong PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_util_getlong PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_util_getlong PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_util_getlong PRIVATE lportsentry)

  add_executable(test_util_createdatetime tests/test_util_createdatetime.c)
  target_compile_options(test_util_createdatetime PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_util_createdatetime PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_util_createdatetime PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_util_createdatetime PRIVATE lportsentry)

  add_executable(test_util_strtouint16 tests/test_util_strtouint16.c)
  target_compile_options(test_util_strtouint16 PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_util_strtouint16 PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_util_strtouint16 PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_util_strtouint16 PRIVATE lportsentry)

  add_executable(test_util_reallocandappend tests/test_util_reallocandappend.c)
  target_compile_options(test_util_reallocandappend PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_util_reallocandappend PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_util_reallocandappend PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_util_reallocandappend PRIVATE lportsentry)

  add_executable(test_state_machine tests/test_state_machine.c)
  target_compile_options(test_state_machine PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_state_machine PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_state_machine PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_state_machine PRIVATE lportsentry)

  add_executable(test_port tests/test_port.c)
  target_compile_options(test_port PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_port PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_port PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_port PRIVATE lportsentry)

  add_executable(test_io_subststring tests/test_io_subststring.c)
  target_compile_options(test_io_subststring PRIVATE ${UNIT_TEST_COMPILE_OPTS})
  target_include_directories(test_io_subststring PRIVATE "${PROJECT_BINARY_DIR}")
  target_link_options(test_io_subststring PRIVATE ${STANDARD_LINK_OPTS})
  target_link_libraries(test_io_subststring PRIVATE lportsentry)

  # Enable testing and add test targets
  enable_testing()
  add_test(NAME test_util_safestrncpy COMMAND $<TARGET_FILE:test_util_safestrncpy>)
  add_test(NAME test_util_getlong COMMAND $<TARGET_FILE:test_util_getlong>)
  add_test(NAME test_util_createdatetime COMMAND $<TARGET_FILE:test_util_createdatetime>)
  add_test(NAME test_util_strtouint16 COMMAND $<TARGET_FILE:test_util_strtouint16>)
  add_test(NAME test_util_reallocandappend COMMAND $<TARGET_FILE:test_util_reallocandappend>)
  add_test(NAME test_state_machine COMMAND $<TARGET_FILE:test_state_machine>)
  add_test(NAME test_port COMMAND $<TARGET_FILE:test_port>)
  add_test(NAME test_io_subststring COMMAND $<TARGET_FILE:test_io_subststring>)
endif()

=== debian/changelog ===
portsentry (2.0.5-2) unstable; urgency=medium

  * Updated German translations, fixing bug (Closes: #1116975)

 -- Marcus Hufvudsson <mh@protohuf.com>  Fri, 03 Oct 2025 03:13:26 +0000

portsentry (2.0.5-1) unstable; urgency=medium

  [ Marcus Hufvudsson ]
  * Update to latest upstream version
  * Fixed lintian warning maintainer-script-lacks-debhelper-token
  * Revert old conf template for now
  * Remove obsolete message and change file encoding for swedish translation
    to UTF8
  * Fixed malformed-title-in-templates
  * Ran debconf-updatepo after fixing template message

  [ Andreas Tille ]
  * d/watch: Fix download name of new upstream source

 -- Marcus Hufvudsson <mh@protohuf.com>  Sun, 14 Sep 2025 16:55:25 +0200

=== debian/control ===
Source: portsentry
Maintainer: Marcus Hufvudsson <mh@protohuf.com>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/portsentry
Vcs-Git: https://salsa.debian.org/debian/portsentry.git
Homepage: https://portsentry.xyz
Rules-Requires-Root: binary-targets

Package: portsentry
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         logrotate
Recommends: fail2ban
Description: Port scan detection and response tool
 Portsentry monitors network traffic in order to detect port scans in real-time.
 It can identify several types of scans, including TCP, SYN, FIN, XMAS, NULL
 scans and UDP probing. It can automatically add the attacker's IP address to
 the system's firewall or access control list, effectively blocking any further
 connections from that IP. It can log the details of the scan attempt,
 including the source IP address, timestamp, and type of scan detected.
 This information can be useful for forensic analysis and monitoring.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBUILD_TESTS=ON -DINSTALL_LICENSE=OFF

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/portsentry/portsentry/tags .*/v?(\d.*)@ARCHIVE_EXT@

## portsentry 2.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,31 @@
 cmake_minimum_required(VERSION 3.10)
-project(portsentry VERSION 2.0.5)
+project(portsentry VERSION 2.0.6)
 include(CheckCCompilerFlag)
 
 option(BUILD_FUZZER "Build fuzzer tests" OFF)
 option(BUILD_TESTS "Build unit tests" OFF)
 option(USE_PCAP "Build with pcap code and link with libpcap" ON)
 option(INSTALL_LICENSE "Install license file" ON)
+option(USE_SYSTEMD "Install systemd unit file" ON)
+
+if (NOT DEFINED CMAKE_BUILD_TYPE)
+  set(CMAKE_BUILD_TYPE "Release")
+endif()
+
+# We're using an absolute path for the systemd unit file, so we need to set the CPack destination directory to ON
+# This is a workaround for the fact that the systemd unit file is installed in a non-standard location. Only affects the use of cpack.
+set(CPACK_SET_DESTDIR "ON")
 
 set(CONFIG_FILE "\"/etc/portsentry/portsentry.conf\"" CACHE STRING "Path to portsentry config file")
 set(WRAPPER_HOSTS_DENY "\"/etc/hosts.deny\"" CACHE STRING "Path to hosts.deny file")
 
-set(STANDARD_COMPILE_OPTS -Wall -Wextra -pedantic -Werror -Wformat -Wformat-security -Wstack-protector -Wshadow -Wredundant-decls -Wdisabled-optimization -Wnested-externs -Wstrict-overflow=2 -Wconversion -Wmissing-prototypes -fPIE -fstack-protector-strong -fstrict-aliasing -fno-common -fno-strict-overflow -D_FORTIFY_SOURCE=2)
+set(STANDARD_COMPILE_OPTS -Wall -Wextra -pedantic -Werror -Wformat -Wformat-security -Wstack-protector -Wshadow -Wredundant-decls -Wdisabled-optimization -Wnested-externs -Wstrict-overflow=2 -Wconversion -Wmissing-prototypes -Wcast-qual -fPIE -fstack-protector-strong -fstrict-aliasing -fno-common -fno-strict-overflow)
+
+string(REGEX MATCH "-D_FORTIFY_SOURCE" FORTIFY_MATCH "${CMAKE_C_FLAGS}")
+
+if(NOT FORTIFY_MATCH)
+  set(STANDARD_COMPILE_OPTS ${STANDARD_COMPILE_OPTS} -D_FORTIFY_SOURCE=2)
+endif()
 
 check_c_compiler_flag("-fcf-protection=full" COMPILER_SUPPORTS_CFI_PROTECTION)
 
@@ -55,6 +70,22 @@
 set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "A port scanning detection tool")
 
 include(CPack)
+
+find_package(PkgConfig QUIET)
+
+if(USE_SYSTEMD AND NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
+  message(STATUS "SYSTEMD_SYSTEM_UNIT_DIR not defined, checking for systemd_system_unit_dir using pkg-config")
+  if(PKG_CONFIG_FOUND)
+    pkg_check_modules(SYSTEMD "systemd")
+  endif()
+
+  if(SYSTEMD_FOUND)
+    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemd_system_unit_dir systemd OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
+    message(STATUS "SYSTEMD_SYSTEM_UNIT_DIR: ${SYSTEMD_SYSTEM_UNIT_DIR}")
+  else()
+    message(FATAL_ERROR "Unable to find systemd using pkg-config, please set SYSTEMD_SYSTEM_UNIT_DIR manually (e.g. /lib/systemd/system)")
+  endif()
+endif()
 
 # LIBPORTSENTRY - Static lib of the portsentry functionallity
 add_library(lportsentry STATIC ${CORE_SOURCE_FILES})
@@ -108,7 +139,15 @@
 if (INSTALL_LICENSE)
   install(FILES LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR})
 endif()
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/init/portsentry.service DESTINATION ${CMAKE_INSTALL_LIBDIR}/systemd/system)
+
+# Allow overriding the systemd unit install directory, could be useful for distro package systems
+if (USE_SYSTEMD)
+  if (DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/init/portsentry.service DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")
+  else()
+    message(FATAL_ERROR "Unable to find systemd using pkg-config, please set SYSTEMD_SYSTEM_UNIT_DIR manually (e.g. /lib/systemd/system)")
+  endif()
+endif()
 
 # PORTCON - helper test program used in system tests
 add_executable(portcon portcon/main.c)
@@ -201,8 +240,3 @@
   add_test(NAME test_util_getlong COMMAND $<TARGET_FILE:test_util_getlong>)
   add_test(NAME test_util_createdatetime COMMAND $<TARGET_FILE:test_util_createdatetime>)
   add_test(NAME test_util_strtouint16 COMMAND $<TARGET_FILE:test_util_strtouint16>)
-  add_test(NAME test_util_reallocandappend COMMAND $<TARGET_FILE:test_util_reallocandappend>)
-  add_test(NAME test_state_machine COMMAND $<TARGET_FILE:test_state_machine>)
-  add_test(NAME test_port COMMAND $<TARGET_FILE:test_port>)
-  add_test(NAME test_io_subststring COMMAND $<TARGET_FILE:test_io_subststring>)
-endif()

=== debian/changelog ===
portsentry (2.0.6-1) unstable; urgency=medium

  * Updated Dutch translations (Closes: #1118208)
  * Updated Portuguese translations (Closes: #1119829)
  * Updated to new upstream version, 2.0.6
  * As of Portsentry 2.0 the default config won't cause bug #795186 to happen.
    (Closes: #795186)

 -- Marcus Hufvudsson <mh@protohuf.com>  Sun, 02 Nov 2025 12:14:07 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Marcus Hufvudsson <mh@protohuf.com>
 Section: net
 Priority: optional
-Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev
+Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev, pkgconf, systemd-dev
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/portsentry
 Vcs-Git: https://salsa.debian.org/debian/portsentry.git
